pr def linear_reg_impute
    args y_var var_list
	
// Impute non-existing y_var with values from linear regression of additive dummies in var_list
tempvar y_var2 y_var3 x_var
tempname b_est
qui describe `var_list', fullnames varlist
local var_list0=r(varlist)

reg `y_var' i.(`var_list0'), vce(robust)
matrix b_est = e(b)
predict `y_var2', xb
replace `y_var'=`y_var2' if `y_var'==.

g `y_var3' = 0
g `x_var' = 0
local k2 = 1

foreach x in `var_list0' {
sum `x'  // Get all values of the variable to use dummy
local t_min = r(min)
local t_max = r(max) 

forv k=`t_min'/`t_max' {
sum `x' if `x'==`k'
local Nobs = r(N)
if `Nobs'>0 { // If dummy for the value exists
replace `x_var' = (`x'==`k')
scalar coef = b_est[1,`k2']
scalar list coef
replace `y_var3' = `y_var3'+`x_var'*coef if `x_var'==1

local k2 = `k2'+1
}
} 
}
scalar coef = b_est[1,`k2']
scalar list coef
replace `x_var'  = coef 
replace `y_var3' = `y_var3'+`x_var'

///
pwcorr `y_var2' `y_var3' if `y_var3'!=0
replace `y_var'=`y_var3' if `y_var'==. & `y_var3'!=0
pwcorr `y_var' `y_var3'
matrix drop b_est

end
