global factor_op "factor_all"
global factor14 "factor_egm"

use "$path_g\\${data_save}_dtbc.dta", clear //use "$path_g\\${data_save}_nie.dta", clear
egen dhT = rowtotal( d_chvp d_chotp )
replace d_vp=max(d_vp,dhT) if dhT>0 & dhT<.
pwcorr d_vp dhT if year>=2014 & a1==1
capture order d_yr2 d_yr3 d_yr4 d_yr5 d_yr6 d_yr7, last
replace estrato_h = 3 if estrato_h>3 & estrato_h<.
capture egen d_dna2=rowtotal(d_td1 d_td2 d_td3 d_td4 d_td5 d_td6 d_td7)
capture replace d_dna=max(d_dna, d_dna2) if a1==1
capture drop d_dna2 
replace d_dt = max(0,d_dt,d_dna,d_vp, max(0,d_dna)+max(0,d_vp)) if a1==1
replace d_vp = max(0,d_dt-max(0,d_dna),d_vp) if a1==1
capture replace d_vp = max(0,d_vp,d_chhip,d_chvp) if a1==1 // d_chhip d_chvp d_chotp
capture replace d_vp = max(0,d_vp,max(0,d_chvp)+max(0,d_chotp)) if a1==1 // d_chhip d_chvp d_chotp
capture replace d_dt = max(0,d_dt, max(0,d_dna)+max(0,d_vp)) if a1==1
g sh_dna = max(0,d_dna)/d_dt
g ln_dt5 = ln(d_td5)
foreach var of varlist ln_dt5 ln_dna {
foreach qr of numlist 90 75 { //11 
quietly qreg `var' ytoth_pi i.(zona2 num_adult tr_edad2 vivprop tedu) i.(year) if a1==1, q(0.`qr') nolog //ing 
predict `var'p`qr' if a1==1
replace `var'p`qr'=exp(`var'p`qr') 
}
}
g min_dna = min(max(0,d_dna),ln_dnap90,2*ln_dnap75) if a1==1
g min_dt5 = min(max(0,d_dna),ln_dnap90,2*ln_dnap75,max(0,d_td5),ln_dt5p90,2*ln_dt5p75) if a1==1
foreach yr of numlist 11 14 17 { //11 
g factor_debt_20`yr' = ceil(${factor`yr'}*min_dna/(5*25000)) if year==20`yr' // d_dna
g factor_Bdebt_20`yr' = ceil(${factor`yr'}*min_dt5/(5*25000)) if year==20`yr'  // d_td5
}
g factor_debt = ceil(${factor_op}*min_dna/(5*25000))  //d_dna
g factor_debt_banco = ceil(${factor_op}*min_dt5/(5*25000)) // min(d_dna,deuda_cons_banco)
g factor_debt_vp = ceil(${factor_op}*min(d_vp,max(0,max(0,d_dt)-max(0,d_dna)))/(5*25000))
g factor_debt_dt = ceil(${factor_op}*d_dt/(5*25000))
drop ln_dt5-ln_dnap75
g ln_dvp = ln(max(0,d_vp, d_dt-max(0,d_dna)))
foreach qr of numlist 90 75 { //11 
quietly qreg ln_dvp ytoth_pi i.(zona2 num_adult tr_edad2 vivprop tedu) i.(year) if a1==1, q(0.`qr') nolog //ing 
predict ln_dvp`qr' if a1==1
replace ln_dvp`qr'=exp(ln_dvp`qr') 
}
g min_dvp = min(max(0,d_vp,d_dt-max(0,d_dna)),ln_dvp90,2*ln_dvp75) if a1==1
foreach yr of numlist 11 14 17 { //11 
g factor_DVP_20`yr' = ceil(${factor`yr'}*min_dvp/(40*25000)) if year==20`yr' 
}
g factor_DVP_1 = ceil(${factor_op}*min_dvp/(40*25000))
drop ln_dvp*
egen d_TBTCC = rowtotal(d_td1 d_td2 d_td3)  //d_td4 d_td5
capture replace d_dna=max(d_dna, d_TBTCC) if a1==1
g ln_dTBTCC = ln(d_TBTCC)
replace ln_dTBTCC = ln(min_dna) if ln_dTBTCC==.
foreach qr of numlist 90 75 { //11 
quietly qreg ln_dTBTCC ytoth_pi i.(zona2 num_adult tr_edad2 vivprop tedu) i.(year) if a1==1, q(0.`qr') nolog //ing 
predict ln_dTBTCC`qr' if a1==1
replace ln_dTBTCC`qr'=exp(ln_dTBTCC`qr') 
}
g min_dTBTCC = min(max(0,d_TBTCC),ln_dTBTCC90,2*ln_dTBTCC75) if a1==1
foreach yr of numlist 11 14 17 { //11 
g factor_dTBTCC_20`yr' = ceil(${factor`yr'}*min_dTBTCC/(40*25000)) if year==20`yr' // d_dna
}
g factor_dTBTCC_1 = ceil(${factor_op}*min(d_vp,max(0,max(0,d_dt)-max(0,d_dna)))/(40*25000))
drop ln_dTBTC* 
g ln_dt = ln(d_dt)
replace ln_dt=ln(min_dna) if ln_dt==.
foreach qr of numlist 90 75 { //11 
quietly qreg ln_dt ytoth_pi i.(zona2 num_adult tr_edad2 vivprop tedu) i.(year) if a1==1, q(0.`qr') nolog //ing 
predict ln_dt`qr' if a1==1
replace ln_dt`qr'=exp(ln_dt`qr') 
}
g min_dt = min(max(0,d_dt),ln_dt90,2*ln_dt75) if a1==1
foreach yr of numlist 11 14 17 { //11 
g factor_DT_20`yr' = ceil(${factor`yr'}*min_dt/(40*25000)) if year==20`yr' // d_dna
}
g factor_DT_1 = ceil(${factor_op}*min(d_vp,max(0,max(0,d_dt)-max(0,d_dna)))/(40*25000))
g min_DC0 = max(0,min_dTBTCC)+max(0,min_dna) if a1==1
foreach yr of numlist 11 14 17 { //11 
g factor_DC_20`yr' = ceil(${factor`yr'}*min_DC/(40*25000)) if year==20`yr' // d_dna
}
g factor_DC_1 = ceil(${factor_op}*min_DC/(40*25000))
drop ln_dt* min_DC0 // min_dvp min_dTBTCC min_dna
egen year_folio_efh = group(year_efh folio_efh)
save "$path_g\\${data_save}_dtbc2.dta", replace //use "$path_g\\${data_save}_nie.dta", clear

local var_list_pr0 = "ing debt_pi_ratio rci_pend_75 us_rci_75 numh edad hombre_casado genero instituto universidad unemp_sect d_z2 d_cc2" // layoffs_sect d_yr2-d_yr${nr_yrs}
local var_list_pr0_vp = "ing debt_dt_pi_ratio rci_pend_75 us_rci_75 numh edad hombre_casado genero instituto universidad unemp_sect d_z2 d_cc2"

probit df_vp `var_list_pr0_vp' if a1==1 & cf_dt>0 & cf_dt!=. & c_vp>0 & c_vp<., vce(robust) iterate(50) 
predict df_vp_m if a1==1 & cf_dt>0 & cf_dt!=.
matrix bc0_2013=e(b) //outreg2 using "$path_g\\probit_df_vp.xls", replace
probit df_dna `var_list_pr0' if a1==1 & cf_dt>0 & cf_dt!=. & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<., vce(robust) iterate(50)
matrix bc2_2013=e(b)
predict df_dnam0 if a1==1 & cf_dt>0 & cf_dt!=.

probit df_dna `var_list_pr0' if a1==1 & cf_dt>0 & cf_dt!=. & year==2007 & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<., vce(robust) iterate(50)
matrix bc2_2007=e(b)
predict df_dna_m07 if a1==1 & cf_dt>0 & cf_dt!=.
probit df_dna `var_list_pr0' if a1==1 & cf_dt>0 & cf_dt!=. & year==2011 & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<., vce(robust) iterate(50)
matrix bc2_2011=e(b)
predict df_dna_m11 if a1==1 & cf_dt>0 & cf_dt!=.
probit df_dna `var_list_pr0' if a1==1 & cf_dt>0 & cf_dt!=. & year==2014 & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<., vce(robust) iterate(50)
matrix bc2_2014=e(b)
predict df_dna_m14 if a1==1 & cf_dt>0 & cf_dt!=.
probit df_dna `var_list_pr0' if a1==1 & cf_dt>0 & cf_dt!=. & year==2017 & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<., vce(robust) iterate(50)
matrix bc2_2017=e(b)
predict df_dna_m17 if a1==1 & cf_dt>0 & cf_dt!=.
g df_dnam= df_dna_m07 if year==2007
replace df_dnam = df_dna_m0 if year>=2008 & year<=2010
replace df_dnam = df_dna_m11 if year>=2011
replace df_dnam = df_dna_m14 if year>=2014
replace df_dnam = df_dna_m17 if year>=2017

g df_dtm = max(0,df_dnam)*(max(0,d_dna)/d_dt) + max(0,df_vp_m)*(1-max(0,d_dna)/d_dt)
g df_dtm0 = df_dnam if d_dt>0 & d_dt<.
replace df_dtm0 = df_vp_m if d_dna==0 & d_vp>0 & d_vp<.
replace df_dtm0 = max(df_dnam,df_vp_m) if d_dna>0 & d_vp>0 & d_vp<.
g df_dtm2 = max(0,df_dnam)*max(0,d_dna) + max(0,df_vp_m)*max(0,d_vp,d_dt-max(0,d_dna))
replace df_dtm2 = df_dtm2/d_dt
save "$path_g\\${data_save}_dtbc2.dta", replace
