*use "$pathbp\EFH_14_allvars.dta"
* Variables demográficas
capture drop a1 //ytot_ind
g a1=(ord==1)
replace a1=a2 if a1!=1 & a2!=1
replace a1=2 if a1==0
capture g zona2=1 if macrozona<.
capture replace zona2=2 if macrozona==4
g numh2 = min(6,numh) if numh<.
sum yoprinm yoprin yosec ylab ypen ysub yotro yai
egen ytot_ind = rowtotal(ylab ypen ysub yotro yai)
replace ytoth=0 if a1==1 & ytoth==.
/* xtile pct_ytot = ytoth if a1==1 [fw=factor_egm], nq(200)
recode pct_ytot 0/70=35 71/100=50 101/120=60 121/136=68 137/150=75 151/160=80 161/170=85 ///
171/176=88 177/180=90 181/184=92 185/188=94 189/190=95 191/192=96 193/194=97 195/196=98 ///
197/198=99 199=99.5 200=100 */
xtile pct_ytot = ytoth if a1==1 [fw=factor_egm], nq(100)
recode pct_ytot 0/30=30 31/50=50 51/65=65 66/80=80 81/90=90 91/94=94 95/98=98 99/100=100

capture drop tedad sexo  // Tramo edad 2011 tedad: 18-24; 25-34; 35-44; 45-54; 55-64; >=65
g sexo = genero
g tedad=edad // Tramo edad 2014 tr_edad: 1  0-34; 2 35-49; 3 50-64; 4 >65
recode tedad 0/17=. 18/24=1 25/34=2 35/44=3 45/54=4 55/64=5 65/130=6

* Nivel educacional 2011 n_educ: 0 Diferencial; 1 Pre-escolar y básica; 2 Media; 3 CFT-Instituto; 4 Universitaria;
*								 5 Postgrado
* Nivel educacional 2014 n_educ: 0 Sin educación; 1 Ed. Diferencial; 2 Pre-escolar y básica; 3 Media; 4 CFT-Instituto
*								 5 Universitaria; 6 Postgrado; 7 Otro
if ${years_educ_op}==0 {
replace n_educ=n_educ-1
}
* variables que mantienen su nombre: numh, edad, ocup

* Cambio de nombre para algunas variabñes
g s = educ  
g desem = desocup 
g ocuph = ocup_h 
g desem_h = desocup_h 
g empl_stat_jh = (desem==0) if a1==1
g tedu = s
recode tedu 0/8=1 9/12=2 13/16=3 17/39=4

* Ingresos
* variables que mantienen su nombre: ylabh, yai, ytoth
g yact=0 // yact no existe en 2014
capture g ytothef = ytotef  // En EFH 2011 ypenh es igual a ypenh+ysubh de EFH 2014
capture g yoth = yotroh  // En EFH 2011 yoth+yaotp es igual a yotroh en EFH 2014

* Activos Inmobiliarios
g vivprop = t_vp   // Tenencia de vivienda propia
g vp = act_vp  // Valor vivienda propria
g cyaotp = t_otp  // Tenencia de otras propiedades
g otp = act_otp  // Valor otras propiedades
*g t_inm=(t_vp==1 | t_otp==1) // Tenencia de activos inmobiliarios
g a_inmob = act_inm // Valor activos inmobiliarios
g viv = act_inm 

* Activos Financieros
* Tenencia de activos financieros (en 2007 no sepreguntaba otros activos gral (i1_9))
/*
rename t_acc	h1_1 		// acciones
rename t_fm	h1_2 		// fondos mutuos
rename t_rf	h1_3 		// renta fija (depósitos a plazo, bonos)
rename t_ca	h1_4 		// cuenta de ahorro (personal, vivienda, educación)
rename t_apv	h1_5 		// apv (apv, cuenta 2, depósitos convenidos)
rename t_rv	h1_6 		// otros activos (opciones, swaps, etc)
rename t_ps	h1_7 		// participación en sociedades
*/
g ca_var 	= t_var		// activos financieros renta variable
g 	ca_fijo = t_fijo	// activos financieros renta fija
g	fin		= t_fin	// activos financieros

* Valor activos financieros (en 2007 no se preguntaba monto de seguro con ahorro)
g ahorro_acc = act_acc			// acciones
g ahorro_fm = act_fm				// fondos mutuos
g ahorro_dp = act_rf				// renta fija (depósitos a plazo, bonos)
g ahorro_bco = act_ca			// cuenta de ahorro (personal, vivienda, educación)
g ahorro_apv = act_apv			// apv (apv, cuenta 2, depósitos convenidos)
g ahorro_af = act_rv				// otros activos (opciones, swaps, etc)
g ahorro_ps = act_ps				// participación en sociedades
g a_var = act_var				// activos financieros renta variable
g a_fijo = act_fijo				// activos financieros renta fija
*g act_fin=act_var+act_fijo				// activos financieros
* Otros tipos de ahorro
* Variables no existen para 2007

* Vehículos
g ca_aut = t_vehic // Tenencia de vehículos
g a_auto = act_vehic // Valor de vehículos

* Agregación de activos
* Tenencias
*g t_reales=(t_vehic==1 | t_vp==1 | t_otp==1)					// activos reales
g atot2 =t_totact						// tenencia total de activos
* Valor
g a_noinm = t_finai						// activos financieros
*g act_reales=act_vehic+act_inm+act_fin		// activos reales
g atoth = act_totact						// valor activos totales

* Deuda Hipotecaria
* Regimen tenencia de vivienda 
/* g reg_vp=0
replace reg_vp=1 if e2==1 | e2==3
replace reg_vp=2 if e2==2 | e2==4
replace reg_vp=3 if e2==5 | e2==6
replace reg_vp=4 if e2>=7  
* Formas de financiamiento
g vp_fs=(e7==1)								// Financiamiento con subsidio
g vp_fch=(e2<=4 & e12==1)	*/				// Financiamiento con crédito hipotecario
g c_vp = t_chvp  // Tenencia de deuda en crédito hipotecario
g div_m = div_chvp // Dividendo vivienda principal
g div_ch = estado_chvp  // Situación de pago dividendo

* Plazos hipotecarios
g plazohipc_pp_m = pp_m_chvp				// plazo por pagar en meses
g plazo_pp_a = pp_a_chvp				// plazo por pagar en años
g plazohip_a = ptot_a_chvp				// plazo total en años
g year_vp = ano_chvp						// año inicio crédito hipotecario
g month_vp = mes_chvp						// mes inicio crédito hipotecario

g dhip_vp = d_chvp  // Deuda hipotecaria vivienda principal
*g div_vp=div_chvp // Dividendo total vivienda principal
*g d_vp=d_chvp  // Deuda total vivienda principal

* Crédito complementario
*g vp_fcc=(e2<=4 & e12==1 & e20==1)			// Tenencia crédito complementario

* Otras Propiedades
g c_otp = t_chotp  // Tenencia de deuda hipotecaria en otras propiedades
g div_m_otp = div_chotp  // Dividendo asociado a otras propiedades
g dhip_otp = d_chotp // Deuda en otras propiedades
* totales otras propiedades
/*g t_dotp=t_chotp								// tenencia deuda otras propiedades
g div_otp=div_chotp							// dividendo total otras propiedades
g d_otp=d_chotp		*/						// deuda total otras propiedades

* Agregación deudas hipotecarias
g tthip = t_tothip						// tenencia deuda hipotecaria
g div = div_tothip						// dividendo hipotecario total
g dhiph = d_tothip						// deuda hipotecaria total

* Deuda de consumo
/* //Líneas
g clin=(d_2>0)
g dlin=d_2
g cfdlin=cf_2
drop cf_2 
* Tarjetas
g ctarj=(d_1>0)
g dtarj=d_1
g cfdtarj=cf_1
drop cf_1
drop t_tcc */

* tenencias
g ctarj = t_tcbco							// tarjetas de crédito bancarias
g clin = t_lcbco							// líneas de crédito bancarias
g ctcc = t_tcc								// tarjetas de casas comerciales
g cbco = t_pbco								// préstamos bancarios
g cfin = t_pcc								// préstamos casas comerciales
g csocial = t_pccaf							// préstamos ccaf o cooperativas
g cauto = t_dauto							// préstamos automotrices
g ceduc = t_deduc							// crédito educacional
g banco = t_dbco								// deuda bancaria
*g t_dcc=(t_tcc==1 | t_pcc==1)					// deuda en casas comerciales
*g t_dcon=(t_dbco==1 | t_dcc==1 | t_pccaf==1)	// deudas de consumo (banco, ccom, ccaf)
g cotros = t_dotras							// otras deudas (9 a 13)
g dtot = t_totnoh							// deudas no hipotecarias

* Cargas financieras
egen cfdtarj = rowtotal( cf_td1_*) //cf_1								// tarjetas de crédito bancarias
egen cfdlin = rowtotal( cf_td2_*) //cf_2								// líneas de crédito
/*rename cfdtcc cf_3								// tarjetas casas comerciales
rename cffin cf_4								// préstamos casas comerciales
rename cfdcbco cf_5								// préstamos bancarios
rename cfdsocial cf_6							// préstamos ccaf o cooperativas
rename cfdauto cf_7								// préstamos automotrices
rename cfdeduc cf_8								// crédito educacional
*/

* Plazo por pagar en meses para cada deuda
forv k=1/3 {
forv m=1/3 {
g pmen_`m'_td`k' = pp_td`k'_`m'
}
}
g pmen_4_td3 = pp_td3_4
forv k=4/8 {
forv m=1/3 {
g pmen_`m'_td`k' = pp_td`k'_`m'
}
}
* Plazo total en meses para deudas 4 a 8
forv k=4/7 {
forv m=1/3 {
g ptot_`m'_td`k' = ptot_td`k'_`m'
}
}
* Monto de deuda residual
g dtarj = d_td1								// tarjetas de crédito bancarias
g dlin = d_td2								// líneas de crédito
egen dtcc = rowtotal(d_td3 d_td4) //g dtcc = d_td3	// tarjetas casas comerciales
g dcbco = d_td5								// préstamos bancarios   //egen dcbco = rowtotal(d_td1 d_td2 d_td5)
egen cfdtcc = rowtotal(cf_td3 cf_td4) //rename cf_cc cfdtcc 
g cfdcbco = cf_td5 // egen cfdcbco = rowtotal(cf_td1 cf_td2 cf_td5) //egen cfdcbco = rowtotal(cf_tcbco cf_lcbco cf_pbco)
g cfdtbco = max(0,cfdcbco) + max(0, max(0,cf_dt)-max(0,cf_dna)) // rename cf_bco cfdtbco
g dtbco = max(0,d_td1) + max(0,d_td2)  //g dtbco = max(0,dcbco) + max(0, max(0,d_dt)-max(0,d_dna))
g dfin = d_td4								// préstamos casas comerciales
g dsocial = d_td6							// préstamos ccaf o cooperativas
g dauto = d_td7								// préstamos automotrices
g deduc = d_td8								// crédito educacional
g dotros = d_dotras							// otras deudas
* Deudas agregadas
g dconsh = d_dna											// deuda no hipotecaria total
g dtoth = d_dtot												// deuda total
g tot = t_dtotal												// tenencia deuda total
* Ratios financieros
replace rdi_dt =rdi_dtotal	if rdi_dt==.						// RDI total
replace rci_dt =rci_dtot	if rci_dt==.
