global exp_op 1 // 0 - Total household spending is considered (Durables+Non-durables), 1 - Only non-durables are considered
global fix_un 0.10 // For stress_test and dynamic_un, unemployment rates are fixed at 10%
global non_par_ds 1 // 0 - Debt, Debt Service and RCI are simulated using parametric distribution, 
// 1 - Debt, Debt Service, and RCI (DSR) are simulated using the bootstrap sampling from each simulation
// and adjusting for changes in aggregate mean debt and debt service only (Only the missing values are parametricaly simulated)
global factor17 "factor_egm"
global factor14 "factor_egm"
global factor11 "factor_cvars1112"
global factor10 "factor_cvars11112_vs3"
global factor09 "factor_cvars1112"
global factor08 "factor_ec_vars1112"
global factor07 "expr0531m"
// Format EFH Data for different years, then join the datasets     /*  */
run "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\Proyectos\2010_Household Risk\simul_format_efh2_17.do" 
run "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\Proyectos\2010_Household Risk\simul_format_efh2_14.do" 
*run "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\Proyectos\2010_Household Risk\simul_format_efh2_10.do"
*run "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\Proyectos\2010_Household Risk\simul_format_efh2_11.do"

*run "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\Proyectos\2010_Household Risk\simul_format_efh2_07.do"
*run "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\Proyectos\2010_Household Risk\simul_format_efh2_08.do"
*run "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\Proyectos\2010_Household Risk\simul_format_efh2_09.do"
local folio_max = 0
local grains "14 17" //"07 08 09 10 11 14 17"
if ${risk_vintage_op}==1  {
foreach k of local grains { //foreach k of numlist 10/11 14 { //2014 //forv k=2007/2011 {
global yk = "`k'"
do "$path_bs_do\EFH_labor_risk_vintage_yeark.do"
}
}
local grains "07 08 09 10 11 14 17"

foreach k of numlist 2014 2017 { // 2007/2009 2010/2011 forv k=2007/2011 { 2007/2009 2010/2011 2014 2017
local k1 = substr(string(`k'),3,4)
use "$path4b\\${data_save}_`k1'.dta", clear
if `k'<2014 {
foreach var of varlist cfdtbco cfdtcc cfdcbco cf_dna d_dna {
rename `var' `var'_orig  //replace `var'=. if a1!=1 
}
*capture drop cfdtbco cfdtcc cfdcbco cf_dna d_dna
joinby folio year using "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\efh_imputada\efh_imputada_median.dta", unmatched(master) update  //efh_imputada_median2
tab _merge
drop _merge
joinby folio year using "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\efh_imputada\efh_imputada_median2.dta", unmatched(master) update  //efh_imputada_median2
tab _merge
drop _merge

egen deuda_cons_banco2 = rowtotal(dcbco dtbco)  /**/
pwcorr deuda_cons_banco* cfdtbco* cfdtcc* cfdcbco* cf_dna* d_dna* if a1==1
sum deuda_cons_banco* cfdtbco* cfdtcc* cfdcbco* cf_dna* d_dna* if a1==1

replace cfdtbco_orig = max(cfdtbco2, cfdtbco_orig)
replace cfdtcc_orig = max(cfdtcc, cfdtcc_orig)
replace cfdcbco_orig = max(cfdcbco, cfdcbco_orig)
replace cf_dna_orig = max(cf_dna, cf_dna_orig)
replace d_dna_orig = max(d_dna, d_dna_orig)
replace deuda_cons_banco=max(deuda_cons_banco,deuda_cons_banco2)
drop cfdtbco- deuda_cons_banco2
local dnames "cfdtbco cfdtcc cfdcbco cf_dna d_dna"
foreach x of local dnames {
rename `x'_orig `x'
} 
}
g folio_efh = folio
egen folio2=group(folio)
replace folio = `folio_max'+folio2
sum folio
local folio_max=r(max)
drop folio2
save "$path4b\\${data_save}_`k1'.dta", replace
}
use "$path4b\\${data_save}_07.dta", clear //use "$path4b\\${data_save}_10.dta", clear  //use "$path4b\\${data_save}_14.dta", clear //use "$path4b\\${data_save}_10.dta", clear
foreach k of numlist 2008/2010 2011 2014 2017 {    //foreach k of numlist 2011 2014 or 2010 2011 {  // 2014 //forv k=2008/2011 {
local k1 = substr(string(`k'),3,4)
joinby folio year using "$path4b\\${data_save}_`k1'.dta", update unmatched(both)
tab _merge
drop _merge
save "$path4b\\${data_save}.dta", replace
}
order folio_efh, first
sort year folio_efh
save "$path4b\\${data_save}.dta", replace

use "$path4b\\${data_save}.dta", clear
sort folio year
replace zona = 4 if zona==.
replace class_comseg_imp = class_com2006 if class_comseg_imp==.
// Create a factor valid for all EFH years
g id_orig = folio // These are the original folio values
drop folio
egen folio = group(id_orig year)

g factor_national = .
quietly {
forv k2=1/2 {
sum a1 if zona2==`k2' & year!=2008 & year!=2009 & year!=2010
local adj_yr0 = r(N)
foreach k of numlist 2007 2011 2014 2017 { //forv k=`yr_first'/2011 {
local k1 = substr(string(`k'),3,4)
sum a1 if year==`k' & zona2==`k2'
local adj_yr1 = r(N)/`adj_yr0'
replace factor_national = ceil(${factor`k1'}*`adj_yr1') if year==`k' & zona2==`k2'
}
}
}
//
global factor_op "factor_all"
g factor_all = .
quietly {
forv k2=1/2 {
sum a1 if zona2==`k2'
local adj_yr0 = r(N)
foreach k of numlist 2007/2009 2010 2011 2014 2017 { //forv k=`yr_first'/2011 {
local k1 = substr(string(`k'),3,4)
if `k2'==1 {
g factor_`k' = ceil(${factor`k1'})
}
sum a1 if year==`k' & zona2==`k2'
local adj_yr1 = r(N)/`adj_yr0'
replace factor_all = ceil(${factor`k1'}*`adj_yr1') if year==`k' & zona2==`k2'
}
}
}
g factor_101114 = .
quietly {
forv k2=1/2 {
sum a1 if zona2==`k2'
local adj_yr0 = r(N)
foreach k of numlist 2010 2011 2014 2017 { //forv k=`yr_first'/2011 {
local k1 = substr(string(`k'),3,4)
sum a1 if year==`k' & zona2==`k2'
local adj_yr1 = r(N)/`adj_yr0'
replace factor_101114 = ceil(${factor`k1'}*`adj_yr1') if year==`k' & zona2==`k2'
}
}
}
g factor_071114 = .
quietly {
forv k2=1/2 {
sum a1 if zona2==`k2'
local adj_yr0 = r(N)
foreach k of numlist 2007 2011 2014 2017 { //forv k=`yr_first'/2011 {
local k1 = substr(string(`k'),3,4)
sum a1 if year==`k' & zona2==`k2'
local adj_yr1 = r(N)/`adj_yr0'
replace factor_071114 = ceil(${factor`k1'}*`adj_yr1') if year==`k' & zona2==`k2'
}
}
} //drop factor_cva* 
tab year, g(d_yr)
global nr_yrs = r(r)
g class_com_max = max(class_com2003, class_com2006)
replace class_com_max = (class_com_max>=2) if class_com_max<.
tab class_com_max, g(d_cc)
tab zona2, g(d_z)
drop class_com_max d_z1 d_cc1

egen id_group = group(factor_all)
save "$path4b\\$data_save.dta", replace

use "$path4b\\$data_save.dta", clear
egen id = group(id_orig year folio)  //if ${esi_bt_op}==0 {  // Original data
rename folio id_orig2 
rename id folio
tab tr_edad2, g(tr_edad2_d)
capture drop _merge
sum zona2 //  Compare quintiles of permanent income and transitory income
local z_min =r(min)
local z_max =r(max)
sum year
local y_min =r(min)
local y_max =r(max)
g decil_h_pi = .
forv k0=`y_min'/`y_max' {
forv k=`z_min'/`z_max' {
sum zona2 if zona2==`k' & a1==1 & year==`k0'
if r(N)>0 {
xtile decil_h0 =  ytot_p_h if zona2==`k' & a1==1 & year==`k0' [fw=${factor_op}], nq(10)
replace decil_h_pi = decil_h0 if decil_h_pi==. & a1==1 & year==`k0' & zona2==`k'
drop decil_h0
}
}
}
g estrato_h_pi = decil_h_pi
recode estrato_h_pi 1/5=1 6/8=2 9=3 10=4
g quintile_h_pi = ceil(decil_h_pi/2)
tab quintile_h_pi quintile_h if a1==1 [fw=${factor_op}]
tab quintile_h_pi quintile_h if a1==1 [fw=${factor_op}], nofreq row
pwcorr ytot_p_h ytoth if a1==1 [fw=${factor_op}]
g bbbb1 = ln(ytot_p_h)
g bbbb2 = ln(ytoth)
pwcorr bbbb1 bbbb2 if a1==1 [fw=${factor_op}]
pwcorr bbbb1 bbbb2 if a1==1 & quintile_h==1  [fw=${factor_op}]
pwcorr bbbb1 bbbb2 if a1==1 & quintile_h==5  [fw=${factor_op}]
pwcorr bbbb1 bbbb2 if a1==1 & quintile_h>=2 & quintile_h<=4 [fw=${factor_op}]
bysort quintile_h: pwcorr bbbb1 bbbb2 if a1==1 [fw=${factor_op}]
bysort year: reg bbbb2 instituto universidad unemp_sect d_z2 d_cc2 if a1==1 [fw=${factor_op}]
drop bbbb1 bbbb2 estrato_h_pi decil_h_pi quintile_h_pi
bysort year estrato_h: sum c_vp if a1==1 & zona2==2 [fw=${factor_op}]
*replace estrato_h = 3 if estrato_h>3
*collapse c_vp if a1==1 & zona2==2 [fw=${factor_op}], by(year estrato_h)
//     //       //           //

// Impute missing values for debt maturities
g debt_pi_ratio = d_dna/(12*max(1,ytot_p_h))
g cf_pi_ratio = cf_dna/max(1,ytot_p_h)
local var_list = "debt_pi_ratio cf_pi_ratio i.(quintile_h)"
foreach x of varlist p_cons p_tbco p_ccom p_cbco p_fin {
g monthly_`x' = `x'
capture drop pr_est* 
sum `x'
local p_min = r(min)
local p_max = r(max)

reg `x'  `var_list' if a1==1
predict pr_est, xb
replace `x'=pr_est if `x'==. & a1==1
replace `x'= min( max( `p_min', `x'), `p_max') if a1==1
replace `x'=. if a1!=1
replace `x' = ceil(`x'/3) // Reduce months to quarters
}
capture drop pr_est* debt_pi_ratio cf_pi_ratio

// Truncate cf_dna and d_dna
local int_rate1 = 0.20/4 
g cup_rate1 = ( `int_rate1' /( 1-((1+`int_rate1')^(-p_cons)) )) // quarterly cupon rate for consumption debt of household 
g cf_dna_original = cf_dna
g d_dna_original = d_dna
//
replace cf_dna = min(cf_dna, d_dna)
replace cf_dna = min(cf_dna, ytot_p_h) if ytot_p_h<. & cf_dna<.
replace cf_dna = min(cf_dna, 0.67*ytot_p_h) if p_cons>=4 & p_cons<=6 & cf_dna<.
replace cf_dna = min(cf_dna, 0.50*ytot_p_h) if p_cons>=7 & p_cons<. & cf_dna<.
g d_dna_maximum = (1/cup_rate1)*1.5*(3*ytot_p_h) if p_cons<. & d_dna<.
replace d_dna_maximum = (1/cup_rate1)*1*(3*ytot_p_h) if p_cons>1 & p_cons<4 & d_dna<.
replace d_dna_maximum = (1/cup_rate1)*0.67*(3*ytot_p_h) if p_cons>=4 & p_cons<=6 & d_dna<.
replace d_dna_maximum = (1/cup_rate1)*0.50*(3*ytot_p_h) if p_cons>=7 & p_cons<. & d_dna<.
replace d_dna = min(d_dna, d_dna_maximum) if d_dna<.
g debt_pi_ratio0 = d_dna_original/(12*max(1,ytot_p_h))
g debt_pi_ratio1 = d_dna/(12*max(1,ytot_p_h))
g cf_pi_ratio0 = cf_dna_original/max(1,ytot_p_h)
g cf_pi_ratio1 = cf_dna/max(1,ytot_p_h)

// Notice that new measures have much fewer large outliers than original reported values
sum d_dna d_dna_original cf_dna cf_dna_original if a1==1 & d_dna>0 & cf_dna>0 [fw=${factor_op}], d
pwcorr d_dna d_dna_original cf_dna cf_dna_original if a1==1 & d_dna>0 & cf_dna>0 [fw=${factor_op}]
sum debt_pi_ratio0 debt_pi_ratio1 cf_pi_ratio0 cf_pi_ratio1 if a1==1 & d_dna>0 & cf_dna>0 [fw=${factor_op}], d
pwcorr debt_pi_ratio0 debt_pi_ratio1 cf_pi_ratio0 cf_pi_ratio1 if a1==1 & d_dna>0 & cf_dna>0 [fw=${factor_op}]
sum debt_pi_ratio0 if d_dna>0 [fw=${factor_op}], d
local debt_max=r(p95) 
sum cf_pi_ratio0 if cf_dna>0 [fw=${factor_op}], d
local cf_max=r(p95)
sum debt_pi_ratio0 debt_pi_ratio1 cf_pi_ratio0 cf_pi_ratio1 if a1==1 & d_dna>0 & cf_dna>0 & debt_pi_ratio0<`debt_max' & cf_pi_ratio0<`cf_max' [fw=${factor_op}], d
pwcorr debt_pi_ratio0 debt_pi_ratio1 cf_pi_ratio0 cf_pi_ratio1 if a1==1 & d_dna>0 & cf_dna>0 & debt_pi_ratio0<`debt_max' & cf_pi_ratio0<`cf_max' [fw=${factor_op}]
  
// Change RCI and total debt service  
replace cf_dt = max(0, cf_dt - max(0,cf_dna_original-cf_dna)) if a1==1
capture drop rci_min1 us_rci_75 rci_pend_75 // DSR (RCI) and censored level  
capture drop yefec    // RCI modificado con regla de max
g yefec = max(0, ytoth - max(0, yai)) if ytoth<. & yai<. & a1==1
replace yefec = ytoth  if yefec==. & a1==1

g rci_min1=min(cf_dt/yefec,1) if a1==1 
replace rci_min1=min(cf_dna/yefec,1) if a1==1 & cf_dt==0
replace rci_min1=min(cf_dna/yefec,1) if a1==1 & cf_dt<cf_dna

g us_rci_75=(rci_min1>0.75) if a1==1 & rci_min1<.
g rci_pend_75= min(0.75, rci_min1) if a1==1 & cf_dt<. & cf_dt>0  //g rci_pend_75=rci_min1*(1-us_rci_75)
replace rci_pend_75= min(0.75, rci_min1) if a1==1 & cf_dna>0 & rci_pend_75==.

drop debt_pi_ratio0 debt_pi_ratio1 cf_pi_ratio0 cf_pi_ratio1 cf_dna_original d_dna_original d_dna_maximum cup_rate1
replace cf_dna = . if d_dna==.
//

// Permanent Income
capture drop ytot_ind_pot ytot_ind2 
bysort year sexo zona2 actividad tr_edad educ quintile_h: egen ytot_ind_pot = median(ytot_ind) if ocup==1 | desem==1
bysort year sexo zona2 tr_edad educ quintile_h: egen ytot_ind_pot_2 = median(ytot_ind) if ocup==1 | desem==1
replace ytot_ind_pot = ytot_ind_pot_2 if actividad==0 | actividad==. | ytot_ind_pot==.
capture drop ytot_ind_pot_2
g ytot_ind2 = ytot_ind
replace ytot_ind2 = (1/2)*ytot_ind_pot if ytot_ind2==. 
replace ytot_ind2 = (1/2)*ytot_ind_pot if ytot_ind2<=(1/2)*ytot_ind_pot & ytot_ind_pot<.
bysort folio: egen ytoth_temp0 = total(ytot_ind2)
egen ytoth_pi = rowtotal(ytoth_temp0 yai yaotp yact)
capture drop ytoth_temp0
replace ytoth_pi = max(0,ytoth_pi- yai, ytoth) if yai<.
replace ytoth_pi = max(0,ytoth_pi, ytoth) if ytoth_pi==.
sum ytoth_pi if ytoth_pi>0
replace ytoth_pi = r(min) if ytoth_pi==. | ytoth_pi<=0
g debt_pi_ratio = d_dna/(12*max(1,ytot_p_h))  //g debt_pi_ratio = d_dna/(12*max(1,ytoth_pi))
replace debt_pi_ratio = min(1, debt_pi_ratio)
g debt_dt_pi_ratio = d_dt/(12*max(1,ytot_p_h))
replace debt_dt_pi_ratio = min(10, debt_dt_pi_ratio)

replace ytoth_pi =ln(1000+ytoth_pi)
g ratio_y_pi = exp(ing)/exp(ytoth_pi)
sum ratio_y_pi if ratio_y_pi>0
replace ratio_y_pi = r(min) if ratio_y_pi==. | ratio_y_pi<=0
g ln_dna = ln(d_dna)

// Income and unemployment risk for maturities of debt  ///   ///
g unemp_sect_2009 = unemp_sect
g layoffs_sect_2009 = layoffs_sect  //replace unemp_sect=. if year>=2010 & year<=2011  //replace layoffs_sect=. if year>=2010 & year<=2011
g year_efh = year
g year_v = year
g quarter_v = 4
foreach k of local grains { //foreach k of numlist 10/11 14 { //2014 //forv k=2007/2011 {
capture drop _merge
joinby year_v quarter_v year_efh folio_efh using "$path_s3\EFH_risk_yq2_`k'.dta", unmatched(master) update
tab _merge
}
//joinby year_v quarter_v folio_efh id_orig id_orig2 using "$path_s3\EFH_risk_yq2_101114.dta", unmatched(master) //update
//replace unemp_sect = unemp_sect_v if year>=2010 & year<=2011 //replace layoffs_sect = layoffs_sect_v if year>=2010 & year<=2011 
drop _merge quarter_v year_v layoffs_sect_v-ytot_p_h_v
sum unemp_sect_2009 unemp_sect layoffs_sect_2009 layoffs_sect if year>=2010 & year<=2011 
sum unemp_sect_2009 unemp_sect layoffs_sect_2009 layoffs_sect if year<2009
pwcorr unemp_sect_2009 unemp_sect layoffs_sect_2009 layoffs_sect if year>=2010 & year<=2011 
pwcorr unemp_sect_2009 unemp_sect layoffs_sect_2009 layoffs_sect if year<2009
sum df_dna cf_dna if cf_dna>0 & cf_dna<. & a1==1
sum cf_dna rci_pe* p_co if cf_dna>0 & cf_dna<. & a1==1
sum rci_pe* p_co if cf_dna>0 & cf_dna<. & a1==1
g p_temp = min(16,p_cons) if a1==1 & p_cons<.
g year_v = year-floor(p_temp/4)
replace year_v = year-1 if year_v==.
replace p_temp = p_temp-4*floor(p_temp/4)
g quarter_v = 4-max(0,p_temp)
replace quarter_v = 4 if quarter_v==.
replace quarter_v = 4 if quarter_v<1
replace year_v=round(year_v)
replace quarter_v=round(quarter_v)
foreach k of local grains { //foreach k of numlist 10/11 14 { //2014 //forv k=2007/2011 {
capture drop _merge
joinby year_v quarter_v year_efh folio_efh using "$path_s3\EFH_risk_yq2_`k'.dta", unmatched(master) update
tab _merge
}
g debt_pi_ratio_v = d_dna/(12*max(1,ytot_p_h_v))
replace debt_pi_ratio_v = min(1, debt_pi_ratio_v) if debt_pi_ratio_v<.
g ln_ytot_p_h_v = ln(max(1,ytot_p_h_v))
sum ln_ytot_p_h_v ytot_p_h_v [fw=factor_all], d
drop _merge quarter_v year_v 

sum df_dna rci_pen* cf_dna if df_dna<. & a1==1
sum cf_dna cf_dt ytoth if df_dna<. & a1==1 &  rci_pend_75==.
capture drop rci_aux unemp_aux debt_aux
g rci_aux = max(0.08, min(rci_pend_75, 0.50)) if rci_pend_75>0 & rci_pend_75<.
g unemp_aux = max(0.02, min(unemp_sect, 0.12)) //if unemp_sect>0 & unemp_sect<.
g debt_aux = max(0.03, min(debt_pi_ratio, 0.60)) if debt_pi_ratio>0 & debt_pi_ratio<.
g UFeyr=19623 if year==2007    // Value of UF
replace UFeyr=21453 if year==2008
replace UFeyr=20943 if year==2009
replace UFeyr=21455 if year==2010
replace UFeyr=22294 if year==2011
replace UFeyr=24627 if year==2014
replace UFeyr=26736 if year==2017
if ${ing_real}==1  {
g exp_ing = exp(ing)
replace exp_ing = exp_ing*(26736/UFeyr) if year<. & UFeyr<.
replace ing=ln(exp_ing) //replace ing = ln(ing)
}
drop if sexo>2
simulate_consumption
drop _merg pr_est //simu_exp_efh exp_ndur_p75 exp_p75 sd_c_sim
joinby zona2 quintile_h num_men num_adult num_sen tr_edad2 vivprop tedu using "$path4b\expenditures_p50_emp3.dta", update unmatched(master)
tab _merge
drop _merge  //sum gasto_tot gasto_no_durable exp_p50 exp_ndur_p50 exp_ndur2_p50 sd_exp_ndur50 arriendo_imputado
joinby zona2 quintile_h num_men num_adult num_sen tr_edad2 vivprop tedu using "$path4b\expenditures_q_sd_emp3.dta", update unmatched(master)
tab _merge
drop _merge
local var_list "zona2 vivprop num_adul num_men num_sen tedu tr_edad2"
quietly {
foreach x of varlist gasto_tot-arriendo_p75 { 
reg `x' i.(`var_list') ytoth_pi if a1==1
predict pr_est if a1==1, xb
replace `x'=pr_est if `x'==.
replace `x'=0 if `x'<0
replace `x'=. if a1!=1
capture drop pr_est* 
replace `x' = `x'*(24627/22844) //if year==2017
}
}
replace cfdcbco = max(cfdcbco, max(0,cf_td1)+max(0,cf_td5)) if year>=2012 & a1==1 //& cfdcbco==.  //    //    //
replace cfdtbco = max(0,cfdcbco)+max(0, max(0,cf_dt)-max(0,cf_dna)) if year>=2012 & a1==1
replace cfdtcc = max(0,cf_td3)+max(0,cf_td4) if year>=2012 & a1==1
replace cfdauto = max(0,cf_td7) if year>=2012 & a1==1
replace cfdsocial = max(0,cf_td6) if year>=2012 & a1==1
replace cfdeduc = max(0,cf_td8) if year>=2012 & a1==1
replace dcbco = max(0,d_td1)+max(0,d_td5) if year>=2012 & a1==1 //& dcbco==.
replace dtbco = max(0,dcbco)+max(0, max(0,d_dt)-max(0,d_dna)) if year>=2012 & a1==1
replace dtcc = max(0,d_td3)+max(0,d_td4) if year>=2012 & a1==1
replace dauto = max(0,d_td7) if year>=2012 & a1==1
replace dsocial = max(0,d_td6) if year>=2012 & a1==1
replace deduc = max(0,d_td8) if year>=2012 & a1==1   //    //    //
sum foli* year*
joinby folio_efh year using "$path4b\\efh_DFVP_Ld.dta", unmatched(both) update
tab _merge
drop _merge
save "$path_g\\${data_save}_dtbc.dta", replace
