*pr def p_income
quietly {
// 0 - Calculates permanent income of the family

// This prevents some workers from receiving too low of an wage (Necessary because some people may report unrealistic low incomes)
g ytot_ind_original = ytot_ind
g inc_workers = ytot_ind if ocup==1
bysort sexo zona2 tr_edad educ quintile_h: egen inc_p75 = pctile(inc_workers), p(80)
bysort sexo zona2 tr_edad educ: egen inc_p75_0 = pctile(inc_workers), p(80)
bysort sexo zona2 tr_edad educ quintile_h: egen inc_p25 = pctile(inc_workers), p(20)
bysort sexo zona2 tr_edad educ: egen inc_p25_0 = pctile(inc_workers), p(20)
replace inc_p75 = max(inc_p75, inc_p75_0)
replace inc_p25 = max(inc_p25, inc_p25_0)
g inc_p25_2 = min(inc_p25, inc_p25_0)
replace ytot_ind = max(ytot_ind, inc_p25_2) if ocup==1

tempvar y_ind_lab y_ind_pot y_ind_pot2 y_ind2 
g ytoth_00 = ytoth 
replace ytoth_00 = max(0,ytoth_00-yai) if yai<.
replace ytoth_00 = max(0,ytoth_00) if ytoth_00==.
sum ytoth_00 if ytoth_00>0
replace ytoth_00 = max(r(min),ytoth_00) if ytoth_00<.
g ytoth_01 = ytoth_00 if ocup==1 & a1==1
bysort year sexo zona2 tr_edad educ: egen ytoth_max = pctile(ytoth_01), p(95) //actividad 
bysort year sexo zona2 tr_edad educ: egen ytoth_min = pctile(ytoth_01), p(5) 
g ytot_01 = ytot_ind if ocup==1 & a1==1
bysort year sexo zona2 tr_edad educ: egen ytot_max = pctile(ytoth_01), p(90) 
bysort year sexo zona2 tr_edad educ: egen ytot_min = pctile(ytoth_01), p(5)
replace ytoth_max = max(ytoth_max, ytoth_00) if ytoth_max<.
replace ytoth_min = min(ytoth_min, ytoth_00) if ytoth_min<.  
drop ytoth_01 ytot_01

g `y_ind_lab' = ytot_ind if ocup==1
bysort year sexo zona2 actividad tr_edad educ: egen `y_ind_pot' = median(`y_ind_lab') if ocup==1 | desem==1
bysort year sexo zona2 tr_edad educ: egen `y_ind_pot2' = median(`y_ind_lab') if ocup==1 | desem==1
replace `y_ind_pot' = `y_ind_pot2' if actividad==0 | actividad==. | `y_ind_pot'==.

g `y_ind2' = ytot_ind
replace `y_ind2' = (1/2)*`y_ind_pot' if `y_ind2'==. 
replace `y_ind2' = (1/2)*`y_ind_pot' if `y_ind2'<=(1/2)*`y_ind_pot' & `y_ind_pot'<.

rename pr_unemployed pr_unemployed1  // create probability of unemployed without quintile information
local var_list "year sexo zona2 tr_edad educ"
bysort `var_list': egen pr_unemployed2 = median(pr_unemployed1)
*mean_wgts pr_unemployed2 pr_unemployed1 "`var_list'" ${factor_op}

local var_list "year sexo zona2 tr_edad educ" //sector_ind 
foreach k of numlist 1 2 {
g ytot_p = rr_inc*ytot_ind*pr_unemployed`k' if ocup==1
replace ytot_p = ytot_p + ( ytot_ind*(1-pr_unemployed`k') ) if ocup==1

replace ytot_p = max(`y_ind2', max(inc_p25, min(inc_p75, ytot_max,(1/rr_inc)*ytot_ind)) )*(1-pr_unemployed`k') if ocup==0
replace ytot_p = ytot_p + (ytot_ind*pr_unemployed`k' ) if ocup==0

replace ytot_p = ytot_ind if ocup==. | ytot_p==.

bysort folio: egen ytot_p_h0 = total(ytot_p)
egen ytot_p_h`k' = rowtotal(ytot_p_h0 yai yaotp yact)

replace ytot_p_h`k' = max(0,ytot_p_h`k'-yai) if yai<.
replace ytot_p_h`k' = max(0,ytot_p_h`k') if ytot_p_h`k'==.
foreach x of varlist ytot_p_h`k' {
capture drop pr_est* 
reg `x' i.(`var_list')
predict pr_est, xb
replace `x'=pr_est if `x'==.
replace `x'=0 if `x'<0
}
replace ytot_p_h`k' = min(ytot_p_h`k', ytoth_max) if ytot_p_h`k'>ytoth_00 & ytot_p_h`k'<.
replace ytot_p_h`k' = max(ytot_p_h`k', ytoth_min) if ytot_p_h`k'<ytoth_00 & ytoth_00<.

sum ytot_p_h`k' if ytot_p_h`k'>0
replace ytot_p_h`k' = r(min) if ytot_p_h`k'==. | ytot_p_h`k'<=0
capture drop ytot_p ytot_p_h0 pr_est*
}
//
g ytot_p_h = min(ytot_p_h1, ytot_p_h2)
bysort `var_list': egen yp_min = pctile(ytot_p_h), p(10)
replace ytot_p_h = max(ytot_p_h, yp_min) if ytot_p_h<.
drop yp_min
noisily {
pwcorr ytot* ytot_p_h ytot_p_h1 ytot_p_h2
drop ytot_p_h1 ytot_p_h2
}
//
rename pr_unemployed1 pr_unemployed
drop inc_workers inc_p25_0 inc_p25 inc_p25_2 ytot_ind inc_p75 inc_p75_0
rename ytot_ind_original ytot_ind
capture drop  ytoth_00 ytoth_max ytoth_min ytot_max ytot_min pr_unemployed2 // ytot_p ytot_p_h0
}
//
*end
