noisily { //quietly noisily
global path_bs_do "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\Proyectos\2010_Household Risk"
global factor_op "factor_egm"
global years_educ_op = 1 // 0 - use years of education, 1 - use last reported education level

use "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\2017\base_imp_2017_all_imp15_ord1.dta", clear
joinby folio ord using "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\2017\EFH_17_allvars.dta", unmatched(both) update
tab _merge
drop _merge
capture drop aux_edad //a1 
sum ocup desocup [fw=factor_egm]
do "$path_bs_do\homologacion_2014_2011_vs3.do"  // Changes variable names to 2011 standards
sum ocup desem desocup [fw=factor_egm]
replace rci_dna = cf_dna/max(1000, ytotef) if rci_dna==0 | rci_dna==.  //replace d_dna = 0 if rci_dna==0 | cf_dna==0 | rci_dna==. | cf_dna==.
replace rci_dt = cf_dt/max(1000, ytotef) if rci_dt==0 | rci_dt==.   //replace d_dt = 0 if rci_dt==0 | cf_dt==0 | rci_dt==. | cf_dt==.

g class_com = 1
replace class_com = 3 if comuna=="VITACURA"
replace class_com = 2 if comuna=="SAN MIGUEL"
replace class_com = 2 if comuna=="NUNOA"
replace class_com = 2 if comuna=="PROVIDENCIA"
replace class_com = 2 if comuna=="LO BARNECHEA"
replace class_com = 2 if comuna=="LA REINA"  //class_comseg2 class_comseg_imp
replace class_com = 2 if comuna=="LAS CONDES" //class_com2 class_com2003 class_com2006 class_com0 class_com2009
local grains "class_com2 class_com2003 class_com2006 class_com0 class_com2009"
foreach x of local grains {
g `x' = class_com
}
g class_comseg = string(class_com)+string(estrato)
destring class_comseg, replace force
local grains "class_comseg2 class_comseg_imp"
foreach x of local grains {
g `x' = class_comseg
}
capture g s = educ  //g a1=(ord==1)
g hombre_casado = estado_civil*genero
replace hombre_casado = (hombre_casado==1)
g universidad = (n_educ>=5 & n_educ<=6)
g instituto = (n_educ==4)
replace instituto = (n_educ==7) if instituto==0
g d_z2 = (zona2==2)
g ytot_ind0 = ylab
replace ytot_ind0 = 0 if ytot_ind0==.
replace ytot_ind = ytot_ind0 if ytot_ind==.
drop ytot_ind0
replace ytot_ind = max(ytot_ind, max(0,yoprinm)+max(0,yoprin)+max(0,yosec)) 
replace ytoth = ytot_ind if ytoth==. & a1==1
replace ytoth = ytot_ind if ytoth==. & a2==1
g yaotp = max(0, ypenh) + max(0,ysubh)  
g yact0 = max(0,yotroh)
replace yact=max(yact,yact0)
drop yact0

* Situación laboral
g tipo_trab=0 if (c6==1 | c6==2 | c6==6) & ord==1
replace tipo_trab=1 if (c6>2 & c6<9 & c6!=6) & ord==1
replace desem = (desocup_h>0) if desem==.  //g desem = desocup  //by folio, sort: egen desem_h=sum(desem)  // same as unempl_h //egen ocuph = total(ocup), by(folio)
sum desem desocup [fw=factor_egm]
g flab_0=0  // same a lfp
replace flab_0=1 if ocup==1 | desem==1
g lfp = flab_0
replace ocup = . if flab_0==0  // These two lines fix strange employment numbers
replace desem = . if flab_0==0
sum ocup desem desocup [fw=factor_egm] 

bysort folio: egen flab=sum(flab_0)
g pet_0=0 // Individuos del hogar en edad de trabajar
replace pet_0=1 if (edad>15 & edad<65) 
replace pet_0=1 if ocup==1 | desem==1
rename pet pet_original
bysort folio: egen pet=sum(pet_0)
g casado=0 if a1==1
replace casado=1 if estado_civil==1 & a1==1
bysort comuna sexo: egen med_edad=median(edad)  // Imputación edad
replace edad=round(med_edad) if edad==.
capture drop tr_edad
g tr_edad=0
replace tr_edad=1 if edad>=15 & edad<25
replace tr_edad=2 if edad>=25 & edad<35
replace tr_edad=3 if edad>=35 & edad<45
replace tr_edad=4 if edad>=45 & edad<55
replace tr_edad=5 if edad>=55 & edad<65
replace tr_edad=5 if edad>=65 
* Tramos de edad 2 - Young, Middle Age, Old
g tr_edad2 = tr_edad
recode tr_edad2 1/2=1 3/4=2 5=3
g edad2 = edad^2
g aux_edad = (edad<=19)
g aux_edad1=(edad>19 & edad<=64)
g aux_edad2 = (edad>64)
bysort folio: egen num_men=sum(aux_edad)
recode num_men (3/.=3) // use 3 or 4 as upper bound
bysort folio: egen num_adult=sum(aux_edad1)
recode num_adult (4/.=4) // use 4 or 5 as upper bound
bysort folio: egen num_sen=sum(aux_edad2)
recode num_sen (1/.=1) // use 1 or 2 as upper bound
bysort comuna sexo tr_edad: egen m_s=median(s)
replace s=round(m_s) if s==. 
g trab=ocuph/flab
replace tr_edad = . if tr_edad==0
replace tr_edad2 = . if tr_edad2==0
capture drop tedad
g tedad=edad
recode tedad 25/34=2 35/44=3 45/54=4 55/64=5
replace tedad = 0 if edad<18
replace tedad = 1 if edad>=18 & edad<25
replace tedad = 6 if edad>=65 & edad<140

g tedad2 = edad if edad>=18
recode tedad2 18/34=1 35/54=2 55/139=3
g nivel = 2 if instituto==1
replace nivel = 3 if univer==1
replace nivel = 1 if univer==0 & instituto==0
bysort comuna sexo tr_edad: egen niv_m=median(nivel)
replace nivel=round(niv_m) if nivel==.
capture rename educ anos_educ
rename nivel educ
sum zona2
local z_min =r(min)
local z_max =r(max)
g decil_h = .
forv k=`z_min'/`z_max' {
xtile decil_h0 =  ytoth if zona2==`k' [fw=${factor_op}], nq(10)
replace decil_h = decil_h0 if decil_h==.
drop decil_h0
}
g decil_h0 = decil_h if a1==1
bysort folio: egen decil_h1 = mean(decil_h)
replace decil_h = ceil(decil_h1) if decil_h==.
drop decil_h0 decil_h1
g estrato_h = decil_h
recode estrato_h 1/5=1 6/8=2 9=3 10=4
g quintile_h = ceil(decil_h/2)

replace numh = min(numh, 7) if numh<.
g debt_pi_ratio = d_dna/(12*max(1,ytoth)) //d_dna rci_dna  ytot_p_h
g yefec = max(0, ytoth - max(0, yai)) if ytoth<. & yai<. & a1==1 // ytotef 
replace yefec = ytoth  if yefec==. & a1==1
replace yefec=ytoth if yefec==.
g ing=ln(yefec+1000)  //g ing =  ln(ytoth)
sum ing, d
replace ing = max(ing, r(p1)) if a1==1

g rci_min1=min(cf_dt/yefec,1) if a1==1 & cf_dt<.
replace rci_min1=min(cf_dna/yefec,1) if a1==1 & cf_dt==0
replace rci_min1=min(cf_dna/yefec,1) if a1==1 & cf_dt<cf_dna
replace rci_min1=min(rci_min1, rci_dt,1) if rci_min1<. & rci_dt<.
g us_rci_75=(rci_min1>0.75) if a1==1 & rci_min1<.
g rci_pend_75= min(0.75, rci_min1) if a1==1 & cf_dt<. & cf_dt>0
replace rci_pend_75= min(0.75, rci_min1) if a1==1 & cf_dna>0 & rci_pend_75==.
*replace rci_pend_75=rci_min1*(1-us_rci_75) if rci_min1<.
g debtor = (d_dna>0) if d_dna<.  
egen deuda_cons_banco = rowtotal(d_td1 d_td2 d_td5)
g banco0 = 0
replace banco0 = 1 if (t_tcbco==1 | t_lcbco==1 | t_pbco==1)  //g banco = (deuda_cons_banco>0 & deuda_cons_banco<.)
tab banco0 banco
replace banco = min(banco, debtor)
drop banco0
capture g c_vp = t_dvp
reg deuda_cons_banco i.(c_vp sexo zona2 tr_edad2 educ quintile_h) if banco==1
predict dtcbco_0
replace deuda_cons_banco = dtcbco_0 if banco==1 & deuda_cons_banco==.
replace deuda_cons_banco = dtcbco_0 if banco==1 & deuda_cons_banco==0
replace deuda_cons_banco = 0 if deuda_cons_banco==.
replace deuda_cons_banco = 0 if a1!=1
replace deuda_cons_banco = max(0,deuda_cons_banco)
replace d_dt = max(0,d_dt,d_dna,d_vp)
g sh_dna = max(0,d_dna)/d_dt

g year = min(2014, 2016)
g quarter=4
g actividad=9
g sector_ind = actividad
recode sector_ind 0/2=1 3/5=2 6/9=3
g constant = 1
capture drop _merge
layoff_jobfind0 22
rename unemployed pr_unemployed

// Probability of unemployment
g factor_un = ceil(${factor_op}*(1/pr_unemployed) )
replace factor_un = 1 if factor_un<1
replace factor_un = ${factor_op} if factor_un==.
g factor_e = ceil(${factor_op}*(1/(1-pr_unemployed)) )
replace factor_e = 1 if factor_e<1
replace factor_e = ${factor_op} if factor_e==.
g dec_renta = decil_h
g quintile_renta = ceil(dec_renta/2)
replace estrato_h=estrato_y if estrato_h==. //replace quintile_h = quintiles if quintile_h==.
replace quintile_renta = quintile_h if quintile_renta==.
tab estrato_h estrato_y //tab quintile_h quintiles 
tab quintile_renta quintile_h

g unemployed = desem 
capture drop _merge
income_shock0 22
run "$path_bs_do\p_income" // Calculates Permanent Income of the Family
drop unemployed 
capture drop _merge quarter year
if ${Labor_2014_op}==2011 {  // Only if one wants to do backward stress test: in general this is not used
run "$path_bs_do\laborvars_change.do" // Calculates Permanent Income of the Family
}
sum `var_list_pr0' constant ytot_p_h
replace debt_pi_ratio = min(debt_pi_ratio, d_dna/(12*max(1,ytot_p_h)) )  //d_dna rci_dna  ytot_p_h
replace debt_pi_ratio = min(1, debt_pi_ratio)
g debt_dt_pi_ratio = d_dt/(12*max(1,ytot_p_h))
replace debt_dt_pi_ratio = min(10, debt_dt_pi_ratio)

//  // Contrucción plazo por deuda
forv k=1/8 {
forv h=1/3 {
           recode pp_td`k'_`h' 0=.
}
egen plazo_td`k'=rmean(pp_td`k'_1 pp_td`k'_2 pp_td`k'_3)
} 
egen p_cons=rmean(plazo_td1 plazo_td2 plazo_td3 plazo_td4 plazo_td5 plazo_td6 plazo_td7 plazo_td8)
capture drop p_tbco 
g p_tbco = plazo_td1
g p_ccom = plazo_td3
g p_cbco = plazo_td4
g p_fin = plazo_td4

// Variables default de deuda: Pedro Roje  //
g df_vp=(e29==3) if ord==1 & e9_3==1 // VersiÃ³n anterior //e36 (2014) e14_3
g df_vp_1=(e29==3 | e29==2) if ord==1 & e9_3==1
g df_hog=0   if ord==1
g df_hog_1=0 if ord==1
forv k=1/3{
replace df_hog=1 if ord==1  & (e29==3 | e70_`k'==3)  //e36 e73
replace df_hog_1=1 if ord==1  & (e29==3 | e29==2 | e70_`k'==3 | e70_`k'==2)
}
g df_dna=.
forv k=1/5 {  // g7
replace df_dna=1 if (g5_`k'==1) & df_vp_1!=1 & ord==1 & cf_dna>0 // g7_
replace df_dna=0 if (g5_`k'==2) & df_vp_1!=1 & ord==1 & cf_dna>0 & df_dna==.
}   
replace df_dna=((g5_1==1 | g5_2==1 | g5_3==1 | g5_4==1 | g5_5==1 | g5_7==1 | g5_8==1) & ord==1 & df_vp_1!=1) if df_dna==0 | df_dna==.
replace df_dna=. if cf_dna==0 | cf_dna==.
replace df_dna=. if ord!=1

//  Additional definition of Default (only valid for EFH 2010, 2011, 2014)
rename df_vp df_vp_original
rename df_dna df_dna_original
// Default de Deuda
capture drop df_vp df_dna
g df_vp = (e29==3) if e9_3==1 & a1==1 // VersiÃ³n anterior //e36 e37 e38 (2014) e14_3
replace df_vp = (e30>=3 & e30<.) if e9_3==1 & a1==1 & e29==2
replace df_vp = (e31==1) if e9_3==1 & a1==1 & df_vp==0
forv k=1/3{
replace df_vp = 0 if df_vp==. & e52_3_`k'==1 // VersiÃ³n anterior //e36 (2014) e14_3 e73_ e74_ e75_
replace df_vp=1 if a1==1  & e52_3_`k'==1 & e70_`k'==3
replace df_vp=1 if a1==1  & e52_3_`k'==1 & e70_`k'==2 & e71_`k'>=3 & e71_`k'<.
replace df_vp=1 if a1==1  & e72_`k'==1 
}
tab df_vp
//   //   //
g df_dna=.
quietly {
forv k2=1/3 {
forv k=4/7 {
replace df_dna=0 if f25_t`k'd`k2'!=. & df_vp!=1 & a1==1 & cf_dna>0 & cf_dna<. & df_dna==. //2014: f26 f27 f28
replace df_dna=1 if f25_t`k'd`k2'==3 & df_vp!=1 & a1==1 & cf_dna>0 & cf_dna<. & df_dna<.
replace df_dna=1 if f25_t`k'd`k2'==2 & f26_t`k'd`k2'>=3 & f26_t`k'd`k2'<97 & df_vp!=1 & a1==1 & cf_dna>0 & cf_dna<. & df_dna<.
replace df_dna=1 if f25_t`k'd`k2'==3 & f26_t`k'd`k2'>=3 & f26_t`k'd`k2'<97 & df_vp!=1 & a1==1 & cf_dna>0 & cf_dna<. & df_dna<.
replace df_dna=1 if f25_t`k'd`k2'==2 & f26_t`k'd`k2'>=1 & f26_t`k'd`k2'<97 & df_vp!=1 & a1==1 & cf_dna>0 & cf_dna<. & df_dna<.
replace df_dna=1 if f25_t`k'd`k2'==1 & f27_t`k'd`k2'==1 & df_vp!=1 & a1==1 & cf_dna>0 & cf_dna<. & df_dna<.
}
replace df_dna=1 if f37_t8d`k2'==4 & df_vp!=1 & a1==1 & cf_dna>0 & cf_dna<. & df_dna<. //f40
}
} // g7
replace df_dna=((g5_1==1 | g5_2==1 | g5_3==1 | g5_4==1 | g5_5==1 | g5_7==1 | g5_8==1)  & ord==1 & df_vp!=1) if (df_dna==0 | df_dna==.) & df_vp!=1 & a1==1 & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<.
replace df_dna=. if cf_dna==0 | cf_dna==.
replace df_dna=. if d_dna==0 | d_dna==.
replace df_dna=. if a1!=1
replace df_vp=. if a1!=1
tab df_dna
tab df_dna df_vp
tab df_vp df_vp_original
tab df_dna df_dna_original
rename df_vp df_vp_new
rename df_dna df_dna_new
rename df_vp_original df_vp 
rename df_dna_original df_dna 
//   //    //    //   //   //   //   //   //    //    //    //   //     //

quietly {
forv k2=1/3 {
foreach num of numlist 70 71 72 { //73 74 75
local num2=`num'+3
rename e`num'_`k2' EDF`num2'_`k2'
}
forv k=4/7 {
rename f25_t`k'd`k2' DF26_t`k'd`k2'
rename f26_t`k'd`k2' DF27_t`k'd`k2'
replace DF27_t`k'd`k2' = . if DF27_t`k'd`k2'<0
replace DF27_t`k'd`k2' = . if DF27_t`k'd`k2'>=97
}  //replace df_dna=1 if f40_t8d`k2'==4 & df_vp!=1 & a1==1 & cf_dna>0 & cf_dna<. & df_dna<.
}
foreach num of numlist 29 30 31 { //36 37 38
local num2=`num'+7
rename e`num' EDF`num2'
}
}
//
/* egen dtcc = rowtotal(d_td3 d_td4)
egen dcbco = rowtotal(d_td1 d_td2 d_td5)
egen cfdtcc = rowtotal(cf_td3 cf_td4) //rename cf_cc cfdtcc 
egen cfdcbco = rowtotal(cf_td1 cf_td2 cf_td5) //egen cfdcbco = rowtotal(cf_tcbco cf_lcbco cf_pbco)
g cfdtbco = max(0,cfdcbco) + max(0, max(0,cf_dt)-max(0,cf_dna)) // rename cf_bco cfdtbco
g dtbco = max(0,dcbco) + max(0, max(0,d_dt)-max(0,d_dna))  */
//    //         //      //
local f21="f20"
local f22="f21"
local f23="f22"
forv k1=4/7 {  // 1/8  //  // Contrucción inicio de la deuda
forv k2=1/3 {  //recode pmen_`h'_td`k' 0=.
foreach x of varlist `f21'_ano_t`k1'd`k2' `f21'_mes_t`k1'd`k2' `f22'_ano_t`k1'd`k2' `f22'_mes_t`k1'd`k2' `f23'_ano_t`k1'd`k2' `f23'_mes_t`k1'd`k2' {
replace `x' = . if `x'>=97
replace `x' = . if `x'<0
}
g meses_apagar_t`k1'd`k2' = (12*max(0,`f23'_ano_t`k1'd`k2') + max(0, `f23'_mes_t`k1'd`k2') ) if `f23'_ano_t`k1'd`k2'!=.  | `f23'_mes_t`k1'd`k2'!=.
replace meses_apagar_t`k1'd`k2' = max(0,`f23'_ano_t`k1'd`k2', `f23'_mes_t`k1'd`k2') if `f23'_ano_t`k1'd`k2'>11 & `f23'_ano_t`k1'd`k2'<.
g meses_inicio_t`k1'd`k2' = (12*max(0,`f21'_ano_t`k1'd`k2') + max(0, `f21'_mes_t`k1'd`k2') ) if `f21'_ano_t`k1'd`k2'!=.  | `f21'_mes_t`k1'd`k2'!=.
replace meses_inicio_t`k1'd`k2' = max(0,`f21'_ano_t`k1'd`k2', `f21'_mes_t`k1'd`k2') if `f21'_ano_t`k1'd`k2'>11 & `f21'_ano_t`k1'd`k2'<.

replace meses_inicio_t`k1'd`k2' = max(0,meses_inicio_t`k1'd`k2'-meses_apagar_t`k1'd`k2') if `f23'_ano_t`k1'd`k2'!=.  | `f23'_mes_t`k1'd`k2'!=.
replace meses_inicio_t`k1'd`k2' = . if `f23'_ano_t`k1'd`k2'==.  & `f23'_mes_t`k1'd`k2'==. & meses_inicio_t`k1'd`k2'<.
replace meses_inicio_t`k1'd`k2' = max(meses_inicio_t`k1'd`k2', 12*max(0,`f22'_ano_t`k1'd`k2') +max(0,`f22'_mes_t`k1'd`k2') ) if `f22'_ano_t`k1'd`k2'==. | `f22'_mes_t`k1'd`k2'==. 
replace meses_inicio_t`k1'd`k2' = max(0, meses_inicio_t`k1'd`k2') if meses_inicio_t`k1'd`k2'<.
}   //egen plazo_td`k'=rmean(pmen_1_td`k' pmen_2_td`k' pmen_3_td`k')	
egen meses_inicio_t`k1' = rowmax(meses_inicio_t`k1'd1 meses_inicio_t`k1'd2 meses_inicio_t`k1'd3)
egen meses_apagar_t`k1' = rowmax(meses_apagar_t`k1'd1 meses_apagar_t`k1'd2 meses_apagar_t`k1'd3)
drop meses_inicio_t`k1'd1 meses_inicio_t`k1'd2 meses_inicio_t`k1'd3 meses_apagar_t`k1'd1 meses_apagar_t`k1'd2 meses_apagar_t`k1'd3
} 
//    //   //

/*
// Variables default de deuda  //
g df_vp=(e14==3) if a1==1 & e12==1
g df_vp_1=(e14==3 | e14==2) if a1==1 & e12==1
g df_hog=0   if a1==1
g df_hog_1=0 if a1==1
forv k=1/3{
replace df_hog=1 if a1==1  & (e14==3 | e42_`k'==3)
replace df_hog_1=1 if a1==1  & (e14==3 | e14==2 | e42_`k'==3 | e42_`k'==2)
}
g df_dna=.
forv k=1/6 {
replace df_dna=1 if (g9_`k'==1) & df_vp_1!=1 & a1==1 & cf_dna>0
replace df_dna=0 if (g9_`k'==2) & df_vp_1!=1 & a1==1 & cf_dna>0 & df_dna==.
}
replace df_dna=((g9_1==1 | g9_2==1 | g9_3==1 | g9_4==1 | g9_5==1 | g9_6==1) & a1==1 & df_vp_1!=1) if df_dna==0 | df_dna==.
replace df_dna=. if cf_dna==0 | cf_dna==.
replace df_dna=. if a1!=1

capture rename g_total gtotal
capture drop  f1_td1- f17_3_td16
capture drop i1_1- l4  */

g tarjetas_bancaria_al_dia = . // 1-Todas tarjetas al dia "Pagó el monto facturado", 2-Peor estado de pago es "Pagó entre el facturado y el mínimo"
// 3-Peor estado de pago es "Pagó el pago mínimo", 4-Peor estado de pago es "No pagó o pagó menos del mínimo", 5-Todas tarjetas reportan "No sabe, no responde"
forv k2=1/3 {  //Tarjetas bancarias
replace f8_t1d`k2'=8 if f8_t1d`k2'<0
recode f8_t1d`k2' 8/9=8
replace tarjetas_bancaria_al_dia = 5 if tarjetas_bancaria_al_dia==. & f8_t1d`k2'==8
replace tarjetas_bancaria_al_dia = 1 if tarjetas_bancaria_al_dia==. & f8_t1d`k2'<8
replace tarjetas_bancaria_al_dia = 1 if tarjetas_bancaria_al_dia==5 & f8_t1d`k2'>=1 & f8_t1d`k2'<8
replace tarjetas_bancaria_al_dia = 2 if tarjetas_bancaria_al_dia<2. & f8_t1d`k2'==2
replace tarjetas_bancaria_al_dia = 3 if tarjetas_bancaria_al_dia<3. & f8_t1d`k2'==3
replace tarjetas_bancaria_al_dia = 4 if tarjetas_bancaria_al_dia<4. & f8_t1d`k2'==4
}
g tarjetas_cc_al_dia = .
forv k2=1/4 {  //Tarjetas de Casas C
replace f8_t3d`k2'=8 if f8_t3d`k2'<0
recode f8_t3d`k2' 8/9=8
replace tarjetas_cc_al_dia = 5 if tarjetas_cc_al_dia==. & f8_t3d`k2'==8
replace tarjetas_cc_al_dia = 1 if tarjetas_cc_al_dia==. & f8_t3d`k2'<8
replace tarjetas_cc_al_dia = 1 if tarjetas_cc_al_dia==5 & f8_t3d`k2'>=1 & f8_t3d`k2'<8
replace tarjetas_cc_al_dia = 2 if tarjetas_cc_al_dia<2. & f8_t3d`k2'==2
replace tarjetas_cc_al_dia = 3 if tarjetas_cc_al_dia<3. & f8_t3d`k2'==3
replace tarjetas_cc_al_dia = 4 if tarjetas_cc_al_dia<4. & f8_t3d`k2'==4
}
//  //

g meses_survey = mese
g year_survey = anoe
g date_survey = ym(year_survey, meses_survey)
format %tm date_survey

g year = 2017
capture gen gtotal = .
capture rename dhip d_vp
//   Extra work to check employment definition    //    //    //
* Desocupados
g petlab = 1 if edad>=15 & edad<.
gen desem_2=.   //0 if petlab==1 // or edad>=15 & edad<.
forvalue k=6/11 {  //6/11
replace desem_2=1 if (petlab==1 & c1==`k' & c2!=1 & c3==1 )
}
replace desem_2=0 if petlab==1 & c1<=5 // Has a main occupation
replace desem_2=0 if petlab==1 & c2==1 // Has a secondary occupation
label var desem_2 "Desocupados"
sum ocup desem desocup desem_2 [fw=factor_egm] 
sum a2 edad if desem!=. & ocup==. // problem is I considered under 15 as unemployed if they had other employed household members: Wrong!!!
di .9574042+.0425958  // Confirms that this variable is exact oposite of previous one
replace desem=. if edad<15
foreach k of numlist 12 98 99 {
replace desem_2=1 if (petlab==1 & c1==`k' & c2!=1 & c3==1 & desem_2==.)
}
replace desem_2=1 if (petlab==1 & c2!=1 & c3==1 & desem_2==.)
*replace desem_2 = (desocup_h>0) if desem_2==. & petlab==1 & (ocup==1 | desem==1)  // Does not work
replace desem_2=. if c4==1 & desem_2==0 // Is retired, not labor force
replace desem=. if c4==1 & desem==0 // Is retired, not labor force
sum ocup desem desocup desem_2 [fw=factor_egm] 
/*foreach k of numlist 6/12 12 98 99 {
tab c3 if c1==`k'
}*/
tab c1 if c3==1 & ocup==0
/*drop desem
g desem = (ocup==0) if ocup!=.*/
sum ocup desem desocup desem_2 [fw=factor_egm] 
tab a2 if desem==. & desem_2==1
replace ocup=0 if ocup==. & desem_2==1
replace desem=1 if desem==. & desem_2==1
replace desocup=1 if desocup==. & desem_2==1
replace ocup=. if desem_2==.
replace desem=. if desem_2==.
replace desocup=. if desem_2==.
sum ocup desem desocup desem_2 [fw=factor_egm] 
replace desocup=desem
drop desem_2 petlab
gen    rda=(d_td1+d_td2 +d_td3 +d_td4 +d_td5 +d_td6 +d_td7 +d_td8 +d_tothip+d_dotras)/max(1,act_totact)  
//g vivprop2 = t_vp  //g tedu2 = nive_edu  //recode tedu2 1/4=1 5/8=2 9/13=3 14/15=4 16=1 17/99=0
//		//		//		//			//			//			//			//	 //

// Contrato Informal c10 c11 c12 c13
g Informal_T=0 if c10<.
replace Informal_T=1 if c10>=3 & c10<=9
replace Informal_T=1 if c11==1
replace Informal_T=1 if c12>=4 & c12<=5
replace Informal_T=1 if c13>=5 & c13<=9 & Informal_T<.
tab Informal_T
replace Informal_T=0 if c13<. & Infor==.
tab Informal_T

sum d_chvp d_vp d_chotp d_otp d_chhip d_tothip
keep folio ord a1 a2 nive_edu* flab_0 pet_0 sh_inc* sexo lfp* sector_ind actividad tedad factor_egm zona2 s ocup desem pet_0 pet casado ///
tr_edad* tedad s ytot* c_vp yefec num_adul num_men num_sen rci* ing rci_pend_75 us_rci_75 numh edad* hombre_casado genero ///
instituto universidad cf* dec_renta educ constant year decil_h estrato_h layoffs_sect jobfind zona*  d_dna quintile* gtotal ///
unemp_sect class_co* yai yaotp yact deuda_cons_banco banco *_sect ytot_p_h d_dt d_vp df_dna df_vp p_cons p_tbco p_ccom p_cbco ///
d_td1 d_td2 d_td3 d_td4 d_td5 d_td6 d_td7 d_td8 d_dotras d_dna d_dt d_dtot d_cons rda  tedu vivprop d_chhip d_chvp d_chotp ///
cf_dna cf_dt cf_dtot cf_td1 cf_td2 cf_td3 cf_td4 cf_td5 cf_td6 cf_td7 cf_td8 cf_dotras c1* c6* c7* c8* Informal_T ///
p_fin tipo_trab df_*_new EDF* DF* dcbco dtbco cfdtbco cfdtcc cfdcbco meses_inicio_t* meses_apagar_t* ///
act_vp act_otp act_inm act_reales f4_* ///
tarjetas_bancaria_al_dia tarjetas_cc_al_dia date_survey folio_2014 d_vp d_otp d_tothip
drop cf_*_*   // yo* yp* year_* year_*_*
//a_var a_fijo a_auto  cfdtbco c_vp  dcbco dtbco cfdtcc cfdcbco
save "$path4b\\${data_save}_17.dta", replace
}
//
