global esi_bt_op 0 // // 1 - Use ESI bootstrap sample for unemployment probs, 0 - Use complete ESI sample for unemployment probs
global data_save_emp "emp1"
global path_empleo "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\Proyectos\2010_Household Risk\household_risk\empleo"
program drop _all
clear
clear matrix
clear mata
drop _all
capture log close
set more off

// 0 - Define paths and format basic data
global path0 "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\Proyectos\2010_Household Risk\household_risk"
global path1 "$path0\simulation_time"
global path2b "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\Proyectos\2010_Household Risk\household_risk\empleo\bases"
global pathdo2 "$path0\empleo"
global path4 "$path0\empleo\bases"
global path4b "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\Proyectos\2010_Household Risk\simulation_time"
global data_save "hist_dynamic_un06_11"
global ln_inc_e 1 // 0 - Income is Normally-distributed, 1 - Income is Log-Normal
global path_bs_do "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\Proyectos\2010_Household Risk"
global path_factores "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\2007\Data\Base_trabajo"
global path_bs_results "$path4"

run "$pathdo2\predict_xb_sd.do" // Algorithms necessary
run "$pathdo2\predict_xb_sd2.do" 
run "$pathdo2\predict_xb_sd2_facs.do" 
run "$pathdo2\predict_xb_sd3.do" 
run "$pathdo2\pctile_wgts2.do" 
run "$pathdo2\mean_wgts2.do" 
run "$pathdo2\linear_reg_impute3.do" 
run "$path_bs_do\layoff_jobfind0" 
run "$path_bs_do\income_shock0"
global factor17 "factor_egm"
global factor14 "factor_egm"
global factor11 "factor_cvars1112"
global factor10 "factor_cvars11112_vs3"
global factor09 "factor_cvars1112"
global factor08 "factor_ec_vars1112"
global factor07 "expr0531m"

global path_g "D:\Docs2\EFH_CDI\Stress_test_probit\graphs"  
*do "$path_bs_do\sensitivity_unemp_shocks.do"  
global path_s1 "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\Proyectos\2010_Household Risk\simulation_time"
global path_s3 "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\Proyectos\2010_Household Risk\simulation_time"
global Labor_2014_op = 2014  
global risk_vintage_op = 0 // 0 - uses labor_risk previously estimated, 1 - run do "$path_bs_do\EFH_labor_risk_vintage_yeark"
global ing_real = 1 // 0 - Ing is nominal, 1 - Ing is in 2014 pesos
global Mit = 1  // mitigadores = 1 for the Covid-19 policy measures // ${Mit}
global Sector = 0 // 0=estrato_h, 1= replace estrato_h with measure of Economic Sector
global STs = "60 135"  // 60 115 135 155  //60 70 85 95 115  //60 70 85 95 100 115   // 60 70 80 85 95 100 115 $STs
global Inc_CF = 0  // 0 both income or financial charge benefits, 1 only income benefits, 2 only financial charge benefits, 3 no benefits
global IFEb = 3   // 0 - No IFE, 1 - First payment, 2 - Second payment, 3 - Plus bono clase media and 10% AFP

run "$path_bs_do\format_AFP.do"
run "$path_bs_do\format_DFVP_Ld.do" 
run "$path_bs_do\multiple_EFHyears_format.do"   
do "$path_bs_do\efh4_dar_dfdna.do"  
do "$path_bs_do\efh4_dar_dfdna_Xk.do" 

global path_g "D:\Docs2\EFH_CDI\Covid_research\WD\graphs"
save "$path_g\\${data_save}_dtbc2.dta", replace

do "$path_bs_do\efh4_stress_test.do" 
clear
